import 'package:intl/intl.dart';
import 'dart:convert';
import 'orm_utills.dart';

class StringOperatorEqualsTo extends GenericFilterOperator
    with SingleOperator, StringSingleOperator, EqualsToOperator {
  StringOperatorEqualsTo(String columnName, String value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  StringOperatorEqualsTo.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class StringOperatorNotEqualsTo extends GenericFilterOperator
    with SingleOperator, StringSingleOperator, EqualsToOperator, NotOperator {
  StringOperatorNotEqualsTo(String columnName, String value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  StringOperatorNotEqualsTo.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class StringOperatorIn extends GenericFilterOperator
    with ListOperator, StrinListgOperator, InOperator {
  StringOperatorIn(String columnName, List<String> value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  StringOperatorIn.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class StringOperatorNotIn extends GenericFilterOperator
    with ListOperator, StrinListgOperator, InOperator, NotOperator {
  StringOperatorNotIn(String columnName, List<String> value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  StringOperatorNotIn.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class StringOperatorBeginsWith extends GenericFilterOperator
    with LikeOperator, SingleOperator, StringBeginsWithOperator {
  StringOperatorBeginsWith(String columnName, String value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  StringOperatorBeginsWith.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class StringOperatorNotBeginsWith extends GenericFilterOperator
    with LikeOperator, NotOperator, SingleOperator, StringBeginsWithOperator {
  StringOperatorNotBeginsWith(String columnName, String value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  StringOperatorNotBeginsWith.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class StringOperatorContains extends GenericFilterOperator
    with LikeOperator, SingleOperator, StringContainsOperator {
  StringOperatorContains(String columnName, String value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  StringOperatorContains.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class StringOperatorNotContains extends GenericFilterOperator
    with LikeOperator, NotOperator, SingleOperator, StringContainsOperator {
  StringOperatorNotContains(String columnName, String value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  StringOperatorNotContains.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class StringOperatorEndsWith extends GenericFilterOperator
    with LikeOperator, SingleOperator, StringEndsWithOperator {
  StringOperatorEndsWith(String columnName, String value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  StringOperatorEndsWith.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class StringOperatorNotEndsWith extends GenericFilterOperator
    with LikeOperator, NotOperator, SingleOperator, StringEndsWithOperator {
  StringOperatorNotEndsWith(String columnName, String value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  StringOperatorNotEndsWith.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class IntegerOperatorEqualsTo extends GenericFilterOperator
    with SingleOperator, EqualsToOperator {
  IntegerOperatorEqualsTo(String columnName, int value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  IntegerOperatorEqualsTo.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class IntegerOperatorNotEqualsTo extends GenericFilterOperator
    with SingleOperator, EqualsToOperator, NotOperator {
  IntegerOperatorNotEqualsTo(String columnName, int value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  IntegerOperatorNotEqualsTo.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class IntegerOperatorIn extends GenericFilterOperator
    with ListOperator, InOperator {
  IntegerOperatorIn(String columnName, List<int> value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  IntegerOperatorIn.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class IntegerOperatorNotIn extends GenericFilterOperator
    with ListOperator, InOperator, NotOperator {
  IntegerOperatorNotIn(String columnName, List<int> value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  IntegerOperatorNotIn.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class IntegerOperatorBetween extends GenericFilterOperator
    with BetweenOperator {
  IntegerOperatorBetween(String columnName, int initialValue, int finalValue,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _initialValue = initialValue;
    _finalValue = finalValue;
  }

  IntegerOperatorBetween.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class IntegerOperatorNotBetween extends GenericFilterOperator
    with BetweenOperator, NotOperator {
  IntegerOperatorNotBetween(String columnName, int initialValue, int finalValue,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _initialValue = initialValue;
    _finalValue = finalValue;
  }

  IntegerOperatorNotBetween.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class IntegerOperatorMoreThan extends GenericFilterOperator
    with SingleOperator, ThanOperator, MoreThanOperator {
  IntegerOperatorMoreThan(String columnName, int value,
      [bool inclusive = false, LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
    _inclusive = inclusive;
  }

  IntegerOperatorMoreThan.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class IntegerOperatorLessThan extends GenericFilterOperator
    with SingleOperator, ThanOperator, LessThanOperator {
  IntegerOperatorLessThan(String columnName, int value,
      [bool inclusive = false, LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
    _inclusive = inclusive;
  }

  IntegerOperatorLessThan.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class NumericOperatorEqualsTo extends GenericFilterOperator
    with SingleOperator, EqualsToOperator {
  NumericOperatorEqualsTo(String columnName, double value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  NumericOperatorEqualsTo.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class NumericOperatorNotEqualsTo extends GenericFilterOperator
    with SingleOperator, EqualsToOperator, NotOperator {
  NumericOperatorNotEqualsTo(String columnName, double value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  NumericOperatorNotEqualsTo.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class NumericOperatorIn extends GenericFilterOperator
    with ListOperator, InOperator {
  NumericOperatorIn(String columnName, List<double> value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  NumericOperatorIn.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class NumericOperatorNotIn extends GenericFilterOperator
    with ListOperator, InOperator, NotOperator {
  NumericOperatorNotIn(String columnName, List<double> value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  NumericOperatorNotIn.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class NumericOperatorBetween extends GenericFilterOperator
    with BetweenOperator {
  NumericOperatorBetween(
      String columnName, double initialValue, double finalValue,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _initialValue = initialValue;
    _finalValue = finalValue;
  }

  NumericOperatorBetween.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class NumericOperatorNotBetween extends GenericFilterOperator
    with BetweenOperator, NotOperator {
  NumericOperatorNotBetween(
      String columnName, double initialValue, double finalValue,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _initialValue = initialValue;
    _finalValue = finalValue;
  }

  NumericOperatorNotBetween.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class NumericOperatorMoreThan extends GenericFilterOperator
    with SingleOperator, ThanOperator, MoreThanOperator {
  NumericOperatorMoreThan(String columnName, double value,
      [bool inclusive = false, LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
    _inclusive = inclusive;
  }

  NumericOperatorMoreThan.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class NumericOperatorLessThan extends GenericFilterOperator
    with SingleOperator, ThanOperator, LessThanOperator {
  NumericOperatorLessThan(String columnName, double value,
      [bool inclusive = false, LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
    _inclusive = inclusive;
  }

  NumericOperatorLessThan.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class OperatorIsTrue extends GenericFilterOperator
    with IsOperator, TrueOperator {
  OperatorIsTrue(columnName, [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation);

  OperatorIsTrue.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class OperatorNotIsTrue extends GenericFilterOperator
    with IsOperator, TrueOperator, NotOperator {
  OperatorNotIsTrue(columnName,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation);

  OperatorNotIsTrue.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class OperatorIsFalse extends GenericFilterOperator
    with IsOperator, FalseOperator {
  OperatorIsFalse(columnName, [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation);

  OperatorIsFalse.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class OperatorNotIsFalse extends GenericFilterOperator
    with IsOperator, FalseOperator, NotOperator {
  OperatorNotIsFalse(columnName,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation);

  OperatorNotIsFalse.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class DateOperatorEqualsTo extends GenericFilterOperator
    with DateOperator, SingleDate, EqualsToOperator {
  DateOperatorEqualsTo(String columnName, DateTime value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  DateOperatorEqualsTo.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class DateOperatorNotEqualsTo extends GenericFilterOperator
    with DateOperator, SingleDate, EqualsToOperator, NotOperator {
  DateOperatorNotEqualsTo(String columnName, DateTime value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  DateOperatorNotEqualsTo.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class DateOperatorIn extends GenericFilterOperator
    with DateOperator, ListDate, InOperator {
  DateOperatorIn(String columnName, List<DateTime> value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  DateOperatorIn.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class DateOperatorNotIn extends GenericFilterOperator
    with DateOperator, ListDate, InOperator, NotOperator {
  DateOperatorNotIn(String columnName, List<DateTime> value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  DateOperatorNotIn.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class DateOperatorBetween extends GenericFilterOperator
    with DateOperator, BetweenOperator, DateBetween {
  DateOperatorBetween(
      String columnName, DateTime initialValue, DateTime finalValue,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _initialValue = initialValue;
    _finalValue = finalValue;
  }

  DateOperatorBetween.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class DateOperatorNotBetween extends GenericFilterOperator
    with DateOperator, BetweenOperator, DateBetween, NotOperator {
  DateOperatorNotBetween(
      String columnName, DateTime initialValue, DateTime finalValue,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _initialValue = initialValue;
    _finalValue = finalValue;
  }

  DateOperatorNotBetween.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class DateOperatorMoreThan extends GenericFilterOperator
    with DateOperator, SingleDate, ThanOperator, MoreThanOperator {
  DateOperatorMoreThan(String columnName, DateTime value,
      [bool inclusive = false, LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
    _inclusive = inclusive;
  }

  DateOperatorMoreThan.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class DateOperatorLessThan extends GenericFilterOperator
    with DateOperator, SingleDate, ThanOperator, LessThanOperator {
  DateOperatorLessThan(String columnName, DateTime value,
      [bool inclusive = false, LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
    _inclusive = inclusive;
  }

  DateOperatorLessThan.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class DateTimeOperatorEqualsTo extends GenericFilterOperator
    with DateOperator, DateTimeOperator, SingleDate, EqualsToOperator {
  DateTimeOperatorEqualsTo(String columnName, DateTime value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  DateTimeOperatorEqualsTo.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class DateTimeOperatorNotEqualsTo extends GenericFilterOperator
    with
        DateOperator,
        DateTimeOperator,
        SingleDate,
        EqualsToOperator,
        NotOperator {
  DateTimeOperatorNotEqualsTo(String columnName, DateTime value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  DateTimeOperatorNotEqualsTo.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class DateTimeOperatorIn extends GenericFilterOperator
    with DateOperator, DateTimeOperator, ListDate, InOperator {
  DateTimeOperatorIn(String columnName, List<DateTime> value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  DateTimeOperatorIn.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class DateTimeOperatorNotIn extends GenericFilterOperator
    with DateOperator, DateTimeOperator, ListDate, InOperator, NotOperator {
  DateTimeOperatorNotIn(String columnName, List<DateTime> value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  DateTimeOperatorNotIn.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class DateTimeOperatorBetween extends GenericFilterOperator
    with DateOperator, DateTimeOperator, BetweenOperator, DateBetween {
  DateTimeOperatorBetween(
      String columnName, DateTime initialValue, DateTime finalValue,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _initialValue = initialValue;
    _finalValue = finalValue;
  }

  DateTimeOperatorBetween.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class DateTimeOperatorNotBetween extends GenericFilterOperator
    with
        DateOperator,
        DateTimeOperator,
        BetweenOperator,
        DateBetween,
        NotOperator {
  DateTimeOperatorNotBetween(
      String columnName, DateTime initialValue, DateTime finalValue,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _initialValue = initialValue;
    _finalValue = finalValue;
  }

  DateTimeOperatorNotBetween.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class DateTimeOperatorMoreThan extends GenericFilterOperator
    with
        DateOperator,
        DateTimeOperator,
        SingleDate,
        ThanOperator,
        MoreThanOperator {
  DateTimeOperatorMoreThan(String columnName, DateTime value,
      [bool inclusive = false, LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
    _inclusive = inclusive;
  }

  DateTimeOperatorMoreThan.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class DateTimeOperatorLessThan extends GenericFilterOperator
    with
        DateOperator,
        DateTimeOperator,
        SingleDate,
        ThanOperator,
        LessThanOperator {
  DateTimeOperatorLessThan(String columnName, DateTime value,
      [bool inclusive = false, LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
    _inclusive = inclusive;
  }

  DateTimeOperatorLessThan.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class TimeOperatorEqualsTo extends GenericFilterOperator
    with DateOperator, TimeOperator, SingleDate, EqualsToOperator {
  TimeOperatorEqualsTo(String columnName, DateTime value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  TimeOperatorEqualsTo.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class TimeOperatorNotEqualsTo extends GenericFilterOperator
    with DateOperator, TimeOperator, SingleDate, EqualsToOperator, NotOperator {
  TimeOperatorNotEqualsTo(String columnName, DateTime value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  TimeOperatorNotEqualsTo.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class TimeOperatorIn extends GenericFilterOperator
    with DateOperator, TimeOperator, ListDate, InOperator {
  TimeOperatorIn(String columnName, List<DateTime> value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  TimeOperatorIn.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class TimeOperatorNotIn extends GenericFilterOperator
    with DateOperator, TimeOperator, ListDate, InOperator, NotOperator {
  TimeOperatorNotIn(String columnName, List<DateTime> value,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
  }

  TimeOperatorNotIn.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class TimeOperatorBetween extends GenericFilterOperator
    with DateOperator, TimeOperator, BetweenOperator, DateBetween {
  TimeOperatorBetween(
      String columnName, DateTime initialValue, DateTime finalValue,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _initialValue = initialValue;
    _finalValue = finalValue;
  }

  TimeOperatorBetween.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class TimeOperatorNotBetween extends GenericFilterOperator
    with DateOperator, TimeOperator, BetweenOperator, DateBetween, NotOperator {
  TimeOperatorNotBetween(
      String columnName, DateTime initialValue, DateTime finalValue,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _initialValue = initialValue;
    _finalValue = finalValue;
  }

  TimeOperatorNotBetween.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class TimeOperatorMoreThan extends GenericFilterOperator
    with
        DateOperator,
        TimeOperator,
        SingleDate,
        ThanOperator,
        MoreThanOperator {
  TimeOperatorMoreThan(String columnName, DateTime value,
      [bool inclusive = false, LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
    _inclusive = inclusive;
  }

  TimeOperatorMoreThan.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

class TimeOperatorLessThan extends GenericFilterOperator
    with
        DateOperator,
        TimeOperator,
        SingleDate,
        ThanOperator,
        LessThanOperator {
  TimeOperatorLessThan(String columnName, DateTime value,
      [bool inclusive = false, LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation) {
    _value = value;
    _inclusive = inclusive;
  }

  TimeOperatorLessThan.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }
}

enum LogicalOperator { none, and, or }

abstract class GenericFilterOperator {
  late LogicalOperator _operation;
  late String _columnName;

  String get _operator => '';
  String get _valueSyntax;

  GenericFilterOperator(
      [this._columnName = '',
      LogicalOperator operation = LogicalOperator.and]) {
    _operation = operation;
  }

  bool _loadMap(GenericFilterOperator obj, Map<String, dynamic> map) {
    if ((map.containsKey('column_name')) && (map.containsKey('operation'))) {
      obj._columnName = map['column_name'];
      obj._operation = LogicalOperator.values[map['operation']];
      return true;
    } else {
      return false;
    }
  }

  String getSqlSyntax([LogicalOperator? operation]) {
    return '${_getAndsyntax(operation)}$_columnName $_operator $_valueSyntax';
  }

  Map<String, dynamic> toMap() {
    return <String, dynamic>{}
      ..addAll({'name': runtimeType.toString()})
      ..addAll({'column_name': _columnName})
      ..addAll({'operation': _operation.index});
  }

  String toJson() {
    return jsonEncode(toMap());
  }

  String _getAndsyntax([LogicalOperator? operation]) {
    var op = _operation;
    if (operation != null) {
      op = operation;
    }
    ;
    if (op == LogicalOperator.and) {
      return ' and ';
    } else if (op == LogicalOperator.or) {
      return ' or ';
    } else {
      return '';
    }
  }
}

class IsNullOperator extends GenericFilterOperator {
  @override
  String get _operator => 'is null';
  @override
  String get _valueSyntax => '';

  IsNullOperator(columnName, [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation);

  IsNullOperator.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }

  @override
  String getSqlSyntax([LogicalOperator? operation]) {
    return '${_getAndsyntax(operation)}$_columnName $_operator';
  }
}

class IsNotNullOperator extends GenericFilterOperator {
  @override
  String get _operator => 'is not null';
  @override
  String get _valueSyntax => '';

  @override
  String getSqlSyntax([LogicalOperator? operation]) {
    return '${_getAndsyntax(operation)}$_columnName $_operator';
  }

  IsNotNullOperator.fromMap(Map<String, dynamic> map) {
    _loadMap(this, map);
  }

  IsNotNullOperator(columnName,
      [LogicalOperator operation = LogicalOperator.and])
      : super(columnName, operation);
}

String getInSyntax(List<dynamic> list,
    [dynamic Function(dynamic value)? operation]) {
  var result = '';
  list.forEach((element) {
    if (operation != null) {
      element = operation(element);
    }
    result += ', $element';
  });

  return '(${result.replaceFirst(', ', '')})';
}

mixin EqualsToOperator on GenericFilterOperator {
  @override
  String get _operator => '=';
}

mixin InOperator on GenericFilterOperator {
  @override
  String get _operator => 'in';
}

mixin LikeOperator on GenericFilterOperator {
  @override
  String get _operator => 'like';
}

mixin MoreThanOperator on ThanOperator {
  @override
  String get _operator => _inclusive ? '>=' : '>';
}

mixin LessThanOperator on ThanOperator {
  @override
  String get _operator => _inclusive ? '<=' : '<';
}

mixin StringSingleOperator on SingleOperator {
  @override
  String get _valueSyntax => "'$_value'";
}

mixin StringBeginsWithOperator on SingleOperator {
  @override
  String get _valueSyntax => "'$_value%'";
}

mixin StringContainsOperator on SingleOperator {
  @override
  String get _valueSyntax => "'%$_value%'";
}

mixin StringEndsWithOperator on SingleOperator {
  @override
  String get _valueSyntax => "'%$_value'";
}

mixin StrinListgOperator on ListOperator {
  @override
  String get _valueSyntax => getInSyntax(_value, quotedStr);
}

mixin NotOperator on GenericFilterOperator {
  @override
  String get _operator {
    switch (super._operator) {
      case '=':
        return '<>';
      case 'is':
        return 'is not';
      default:
        return 'not ${super._operator}';
    }
  }
}

mixin IsOperator on GenericFilterOperator {
  @override
  String get _operator => 'is';
}

mixin TrueOperator on GenericFilterOperator {
  @override
  String get _valueSyntax => 'true';
}

mixin FalseOperator on GenericFilterOperator {
  @override
  String get _valueSyntax => 'false';
}

mixin DateOperator on GenericFilterOperator {
  String get _dtFormat => 'yyyy-MM-dd';
  String _format(dynamic value, [bool withQuotes = true]) {
    if (withQuotes) {
      return quotedStr(DateFormat(_dtFormat).format(value));
    } else {
      return DateFormat(_dtFormat).format(value);
    }
  }
}

mixin SingleDate on DateOperator {
  late DateTime _value;
  @override
  String get _valueSyntax => '${_format(_value)}';

  @override
  bool _loadMap(GenericFilterOperator obj, Map<String, dynamic> map) {
    var result = false;
    if (super._loadMap(obj, map)) {
      if (obj is SingleDate) {
        if (map.containsKey('value')) {
          obj._value = map['value'];
          result = true;
        }
      }
    }

    return result;
  }

  @override
  Map<String, dynamic> toMap() {
    return super.toMap()..addAll({'value': _value});
  }
}

mixin ListDate on DateOperator {
  late List<DateTime> _value;
  @override
  String get _valueSyntax => getInSyntax(_value, _format);

  @override
  bool _loadMap(GenericFilterOperator obj, Map<String, dynamic> map) {
    var result = false;
    if (super._loadMap(obj, map)) {
      if (obj is ListDate) {
        if (map.containsKey('value')) {
          obj._value = map['value'];
          result = true;
        }
      }
    }

    return result;
  }

  @override
  Map<String, dynamic> toMap() {
    return super.toMap()..addAll({'value': _value});
  }
}

mixin DateBetween on DateOperator, BetweenOperator {
  @override
  String get _valueSyntax =>
      '${_format(_initialValue)} and ${_format(_finalValue)}';
}

mixin DateTimeOperator on DateOperator {
  @override
  String get _dtFormat => 'yyyy-MM-dd HH:mm:ss';
}

mixin TimeOperator on DateOperator {
  @override
  String get _dtFormat => 'HH:mm:ss';
}

mixin SingleOperator on GenericFilterOperator {
  late dynamic _value;

  @override
  String get _valueSyntax => '$_value';

  @override
  bool _loadMap(GenericFilterOperator obj, Map<String, dynamic> map) {
    var result = false;
    if (super._loadMap(obj, map)) {
      if (obj is SingleOperator) {
        if (map.containsKey('value')) {
          obj._value = map['value'];
          result = true;
        }
      }
    }

    return result;
  }

  @override
  Map<String, dynamic> toMap() {
    return super.toMap()..addAll({'value': _value});
  }
}

mixin ThanOperator on GenericFilterOperator {
  bool _inclusive = false;

  @override
  Map<String, dynamic> toMap() {
    return super.toMap()..addAll({'inclusive': _inclusive});
  }

  @override
  bool _loadMap(GenericFilterOperator obj, Map<String, dynamic> map) {
    var result = false;
    if (super._loadMap(obj, map)) {
      if (obj is ThanOperator) {
        if (map.containsKey('inclusive')) {
          obj._inclusive = map['inclusive'];
          result = true;
        }
      }
    }

    return result;
  }
}

mixin BetweenOperator on GenericFilterOperator {
  late dynamic _initialValue;
  late dynamic _finalValue;

  @override
  String get _operator => 'between';
  @override
  String get _valueSyntax => '$_initialValue and $_finalValue';

  @override
  bool _loadMap(GenericFilterOperator obj, Map<String, dynamic> map) {
    var result = false;
    if (super._loadMap(obj, map)) {
      if (obj is BetweenOperator) {
        if (map.containsKey('initial_value')) {
          obj._initialValue = map['initial_value'];
          if (map.containsKey('final_value')) {
            obj._finalValue = map['final_value'];
            result = true;
          }
        }
      }
    }

    return result;
  }

  @override
  Map<String, dynamic> toMap() {
    return super.toMap()
      ..addAll({'initial_value': _initialValue, 'final_value': _finalValue});
  }
}

mixin ListOperator on GenericFilterOperator {
  late List<dynamic> _value;

  @override
  String get _valueSyntax => getInSyntax(_value);

  @override
  bool _loadMap(GenericFilterOperator obj, Map<String, dynamic> map) {
    var result = false;
    if (super._loadMap(obj, map)) {
      if (obj is ListOperator) {
        if (map.containsKey('value')) {
          obj._value = map['value'];
          result = true;
        }
      }
    }

    return result;
  }

  @override
  Map<String, dynamic> toMap() {
    return super.toMap()..addAll({'value': _value});
  }
}
