import 'package:test/test.dart';
import 'package:static_postgres_orm/src/domain/orm_ordenator.dart';

void main() {
  group('ColumnOrdenator', () {
    test('implicit', () {
      var ord = ColumnOrdenator('code');
      expect(ord.toString(), 'code ASC');
    });

    test('explicit asc', () {
      var ord = ColumnOrdenator('code', OrdType.asc);
      expect(ord.toString(), 'code ASC');
    });

    test('explicit desc', () {
      var ord = ColumnOrdenator('code', OrdType.desc);
      expect(ord.toString(), 'code DESC');
    });
  });

  group('GenericOrderBy', () {
    test('1 record', () {
      var ord = GenericOrderBy()..add(ColumnOrdenator('code', OrdType.desc));
      expect(ord.toString(), 'ORDER BY code DESC');
    });

    test('2 record', () {
      var ord = GenericOrderBy()
        ..add(ColumnOrdenator('code', OrdType.desc))
        ..add(ColumnOrdenator('id', OrdType.asc));
      expect(ord.toString(), 'ORDER BY code DESC, id ASC');
    });

    test('empty', () {
      var ord = GenericOrderBy();
      expect(ord.toString(), '');
    });
  });
}
